"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .tmodel import TModel, TModelTypedDict
from opperai.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
from pydantic import model_serializer
from typing_extensions import NotRequired, TypedDict


class ListFunctionsResponseItemTypedDict(TypedDict):
    id: str
    r"""The ID of the function"""
    name: str
    r"""The name of the function"""
    revision_id: str
    r"""The ID of the latest revision of the function"""
    description: NotRequired[Nullable[str]]
    r"""The description of the function"""
    instructions: NotRequired[Nullable[str]]
    r"""The instructions of the function"""
    model: NotRequired[Nullable[TModelTypedDict]]
    r"""The model of the function"""


class ListFunctionsResponseItem(BaseModel):
    id: str
    r"""The ID of the function"""

    name: str
    r"""The name of the function"""

    revision_id: str
    r"""The ID of the latest revision of the function"""

    description: OptionalNullable[str] = UNSET
    r"""The description of the function"""

    instructions: OptionalNullable[str] = UNSET
    r"""The instructions of the function"""

    model: OptionalNullable[TModel] = UNSET
    r"""The model of the function"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["description", "instructions", "model"]
        nullable_fields = ["description", "instructions", "model"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
