"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from opperai.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
from pydantic import model_serializer
from typing_extensions import NotRequired, TypedDict


class ListLanguageModelsResponseTypedDict(TypedDict):
    hosting_provider: str
    r"""The hosting provider of the model"""
    name: str
    r"""The name of the model"""
    location: str
    r"""The location of the model"""
    input_cost_per_token: NotRequired[Nullable[float]]
    r"""The cost in USD per token for input"""
    output_cost_per_token: NotRequired[Nullable[float]]
    r"""The cost in USD per token for output"""


class ListLanguageModelsResponse(BaseModel):
    hosting_provider: str
    r"""The hosting provider of the model"""

    name: str
    r"""The name of the model"""

    location: str
    r"""The location of the model"""

    input_cost_per_token: OptionalNullable[float] = UNSET
    r"""The cost in USD per token for input"""

    output_cost_per_token: OptionalNullable[float] = UNSET
    r"""The cost in USD per token for output"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["input_cost_per_token", "output_cost_per_token"]
        nullable_fields = ["input_cost_per_token", "output_cost_per_token"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
